package hu.bme.mit.example.codegenerator.velocityexample;

import java.util.Map;

import org.apache.velocity.VelocityContext;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.osgi.framework.Bundle;

import PetriNets.petrinet.PetriNet;
import PetriNets.petrinet.PetrinetPackage;

public class PNMLVelocityGenerator {
	
	private static final String BUNDLE_SYMBOLIC_NAME = "hu.bme.mit.example.codegenerator";
	
	public boolean generatePNML(IResource fileResource){
		final Bundle currentBundle = Platform.getBundle(BUNDLE_SYMBOLIC_NAME);
		
		/** Get package **/
		PetrinetPackage.eINSTANCE.eClass();
		
		// Register the XMI resource factory for the .petrinet extension (local!)

		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;
		Map<String, Object> m = reg.getExtensionToFactoryMap();
		m.put("petrinet", new XMIResourceFactoryImpl());

		// Obtain a new resource set
		ResourceSet resSet = new ResourceSetImpl();
		
		//create a resource reference on the EMF serialized from
		Resource resource = resSet.getResource(URI.createURI(fileResource.getRawLocationURI().toASCIIString()), true);
		// Get the first model element and cast it to the right type, usually the root element
		
		//finish the code by getting the model /resource.getContents().get(0); :-)
		PetriNet pn = (PetriNet) resource.getContents().get(0);
		
		//create the context for the template
		VelocityContext context = null;
		// TODO intitialize context here
		
		Job myJob = new Petrinet2PNMLVelocityJob("MyPetriJob", currentBundle, fileResource, context);
		myJob.schedule();
		
		return true;
	}

}
