package hu.bme.mit.example.codegenerator.velocityexample;

import java.io.FileWriter;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.jobs.Job;
import org.osgi.framework.Bundle;

public class Petrinet2PNMLVelocityJob extends Job {

	IResource fileResource;
	Bundle currentBundle;
	VelocityContext context;
	private static final String VELOCITY_TEMPLATE_FILE_NAME = "petri2pnml.vm";
	private static final String TEMPLATES_PATH = "/templates/";
	
	public Petrinet2PNMLVelocityJob(String name, Bundle currentBundle, IResource fileResource, VelocityContext currentContext) {
		super(name);
		this.fileResource = fileResource;
		this.currentBundle = currentBundle;
		this.context = currentContext;
	}
	
	@Override
	protected IStatus run(IProgressMonitor monitor) {
		try {
			monitor.beginTask("Generate PNML" , monitor.UNKNOWN);
			// setup
			String path = FileLocator.toFileURL(currentBundle.getEntry(TEMPLATES_PATH))
					.getFile();
			VelocityEngine velocityEngine = new VelocityEngine();
			
			velocityEngine.addProperty(Velocity.FILE_RESOURCE_LOADER_PATH, path);
			velocityEngine.init();

			Template template = null;
			try {
				template = velocityEngine.getTemplate(VELOCITY_TEMPLATE_FILE_NAME);
			} catch (ResourceNotFoundException rnfe) {
				System.out.println("Example : error : cannot find template "
						+ VELOCITY_TEMPLATE_FILE_NAME);
			} catch (ParseErrorException pee) {
				System.out.println("Example : Syntax error in template "
						+ VELOCITY_TEMPLATE_FILE_NAME + ":" + pee);
			}

			FileWriter writer = new FileWriter(fileResource.getLocation()
					.addFileExtension("pnml").toOSString());
			// /BufferedWriter writer = new BufferedWriter(
			// new OutputStreamWriter(System.out));
			if (template != null)
				template.merge(context, writer);

			//writer.flush();
			writer.close();
		} catch (Exception e) {
			System.out.println(e);
		}
		monitor.done();
		return org.eclipse.core.runtime.Status.OK_STATUS;
	}
}
